searchNodes=[{"doc":"EdgeDB driver for Elixir. EdgeDB module provides an API to run a connection pool, query EdgeDB, perform transactions and subtransactions and their rollback. A simple example of how to use it: iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; EdgeDB . query! ( pid , &quot; ...(2)&gt; SELECT Person{ ...(2)&gt; first_name, ...(2)&gt; middle_name, ...(2)&gt; last_name ...(2)&gt; } FILTER .last_name = &lt;str&gt;$last_name; ...(2)&gt; &quot; , last_name : &quot;Radcliffe&quot; ) # EdgeDB.Set &lt; { # EdgeDB.Object &lt; first_name := &quot;Daniel&quot; , middle_name := &quot;Jacob&quot; , last_name := &quot;Radcliffe&quot; &gt; } &gt;","ref":"EdgeDB.html","title":"EdgeDB","type":"module"},{"doc":"Mark the connection as read-only. This function will mark the connection as read-only, so any modifying queries will return errors.","ref":"EdgeDB.html#as_readonly/1","title":"EdgeDB.as_readonly/1","type":"function"},{"doc":"Creates a child specification for the supervisor to start the EdgeDB pool. See start_option/0 for supported connection options.","ref":"EdgeDB.html#child_spec/1","title":"EdgeDB.child_spec/1","type":"function"},{"doc":"Execute the query on the connection and return the results as a {:ok, set} tuple if successful, where set is EdgeDB.Set . iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , % EdgeDB.Set { } = set } = EdgeDB . query ( pid , &quot;SELECT 42&quot; ) iex(3)&gt; set # EdgeDB.Set &lt; { 42 } &gt; If an error occurs, it will be returned as a {:error, exception} tuple where exception is EdgeDB.Error . iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; { :error , % EdgeDB.Error { } = error } = EdgeDB . query ( pid , &quot;SELECT UndefinedType&quot; ) iex(2)&gt; raise error ** (EdgeDB.Error) InvalidReferenceError: object type or alias &#39;default::UndefinedType&#39; does not exist If a query has arguments, they can be passed as a list for a query with positional arguments or as a list of keywords for a query with named arguments. iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , % EdgeDB.Set { } = set } = EdgeDB . query ( pid , &quot;SELECT &lt;int64&gt;$0&quot; , [ 42 ] ) iex(3)&gt; set # EdgeDB.Set &lt; { 42 } &gt; iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , % EdgeDB.Set { } = set } = EdgeDB . query ( pid , &quot;SELECT &lt;int64&gt;$arg&quot; , arg : 42 ) iex(3)&gt; set # EdgeDB.Set &lt; { 42 } &gt; Automatic retries of read-only queries If the driver is able to recognize the query as a read-only query (i.e. the query does not change the data in the database using DELETE , INSERT or other statements), then the driver will try to repeat the query automatically (as long as the query is not executed in a transaction, because then retrying transactions are used). See query_option/0 for supported options.","ref":"EdgeDB.html#query/4","title":"EdgeDB.query/4","type":"function"},{"doc":"Execute the query on the connection and return the results as EdgeDB.Set . If an error occurs while executing the query, it will be raised as as an EdgeDB.Error exception. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query!/4","title":"EdgeDB.query!/4","type":"function"},{"doc":"Execute the query on the connection and return the results as a {:ok, json} tuple if successful, where json is JSON encoded string. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_json/4","title":"EdgeDB.query_json/4","type":"function"},{"doc":"Execute the query on the connection and return the results as JSON encoded string. If an error occurs while executing the query, it will be raised as as an EdgeDB.Error exception. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_json!/4","title":"EdgeDB.query_json!/4","type":"function"},{"doc":"Execute the query on the connection and return a singleton-returning result as a {:ok, result} tuple. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_required_single/4","title":"EdgeDB.query_required_single/4","type":"function"},{"doc":"Execute the query on the connection and return a singleton-returning result. If an error occurs while executing the query, it will be raised as an EdgeDB.Error exception. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_required_single!/4","title":"EdgeDB.query_required_single!/4","type":"function"},{"doc":"Execute the query on the connection and return a singleton-returning result as a {:ok, json} tuple. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_required_single_json/4","title":"EdgeDB.query_required_single_json/4","type":"function"},{"doc":"Execute the query on the connection and return a singleton-returning result as JSON string. If an error occurs while executing the query, it will be raised as an EdgeDB.Error exception. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_required_single_json!/4","title":"EdgeDB.query_required_single_json!/4","type":"function"},{"doc":"Execute the query on the connection and return an optional singleton-returning result as a {:ok, result} tuple. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_single/4","title":"EdgeDB.query_single/4","type":"function"},{"doc":"Execute the query on the connection and return an optional singleton-returning result. If an error occurs while executing the query, it will be raised as an EdgeDB.Error exception. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_single!/4","title":"EdgeDB.query_single!/4","type":"function"},{"doc":"Execute the query on the connection and return an optional singleton-returning result as a {:ok, json} tuple. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_single_json/4","title":"EdgeDB.query_single_json/4","type":"function"},{"doc":"Execute the query on the connection and return an optional singleton-returning result as JSON encoded string. If an error occurs while executing the query, it will be raised as an EdgeDB.Error exception. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_single_json!/4","title":"EdgeDB.query_single_json!/4","type":"function"},{"doc":"Rollback an open transaction or subtransaction. By default EdgeDB.rollback/2 will abort the transaction/subtransaction function and return to the external scope. But subtransactions can skip this behavior and continue executing after the rollback using the :continue option. See rollback_option/0 for supported options. iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; { :error , :tx_rollback } = ...(2)&gt; EdgeDB . transaction ( pid , fn tx_conn -&gt; ...(2)&gt; EdgeDB . rollback ( tx_conn , reason : :tx_rollback ) ...(2)&gt; end ) iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; { :error , :subtx_rollback } = ...(2)&gt; EdgeDB . transaction ( pid , fn tx_conn -&gt; ...(2)&gt; { :error , reason } = ...(2)&gt; EdgeDB . subtransaction ( tx_conn , fn subtx_conn -&gt; ...(2)&gt; EdgeDB . rollback ( subtx_conn , reason : :subtx_rollback ) ...(2)&gt; end ) ...(2)&gt; EdgeDB . rollback ( tx_conn , reason : reason ) ...(2)&gt; end ) iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , 42 } = ...(2)&gt; EdgeDB . transaction ( pid , fn tx_conn -&gt; ...(2)&gt; { :ok , result } = ...(2)&gt; EdgeDB . subtransaction ( tx_conn , fn subtx_conn -&gt; ...(2)&gt; EdgeDB . rollback ( subtx_conn , continue : true ) ...(2)&gt; EdgeDB . query_required_single! ( subtx_conn , &quot;SELECT 42&quot; ) ...(2)&gt; end ) ...(2)&gt; result ...(2)&gt; end )","ref":"EdgeDB.html#rollback/2","title":"EdgeDB.rollback/2","type":"function"},{"doc":"Creates a pool of EdgeDB connections linked to the current process. If the first argument is a string, it will be assumed to be the DSN and passed as [dsn: dsn] keyword list to connect. iex(1)&gt; { :ok , _pid } = EdgeDB . start_link ( &quot;edgedb://edgedb:edgedb@localhost:5656/edgedb&quot; ) Otherwise, if the first argument is a list, it will be used as is to connect. See start_option/0 for supported connection options. iex(1)&gt; { :ok , _pid } = EdgeDB . start_link ( instance : &quot;edgedb_elixir&quot; )","ref":"EdgeDB.html#start_link/1","title":"EdgeDB.start_link/1","type":"function"},{"doc":"Creates a pool of EdgeDB connections linked to the current process. The first argument is the string which will be assumed as the DSN and passed as [dsn: dsn] keyword list along with other options to connect. See start_option/0 for supported connection options. iex(1)&gt; { :ok , _pid } = EdgeDB . start_link ( &quot;edgedb://edgedb:edgedb@localhost:5656/edgedb&quot; , tls_security : :insecure )","ref":"EdgeDB.html#start_link/2","title":"EdgeDB.start_link/2","type":"function"},{"doc":"Open a subtransaction inside an already open transaction. The result of the subtransaction is the {:ok, result} tuple, where result is the result of the callback function executed in the subtransaction. To rollback an open subtransaction, use EdgeDB.rollback/2 . A subtransaction can be rolled back without exiting the subtransaction block. See rollback_option/0 . EdgeDB.subtransaction/2 calls can be nested multiple times. Each new call to EdgeDB.subtransaction/2 will declare a new savepoint for the current transaction. iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , tickets } = ...(2)&gt; EdgeDB . transaction ( pid , fn tx_conn -&gt; ...(2)&gt; { :ok , tickets } = ...(2)&gt; EdgeDB . subtransaction ( tx_conn , fn subtx_conn1 -&gt; ...(2)&gt; { :ok , tickets } = ...(2)&gt; EdgeDB . subtransaction ( subtx_conn1 , fn subtx_conn2 -&gt; ...(2)&gt; EdgeDB . query! ( subtx_conn2 , &quot;INSERT Ticket{ number := 2}&quot; ) ...(2)&gt; EdgeDB . query! ( subtx_conn2 , &quot;SELECT Ticket{ number }&quot; ) ...(2)&gt; end ) ...(2)&gt; tickets ...(2)&gt; end ) ...(2)&gt; tickets ...(2)&gt; end ) iex(3)&gt; tickets # EdgeDB.Set &lt; { # EdgeDB.Object &lt; number := 2 &gt; } &gt;","ref":"EdgeDB.html#subtransaction/2","title":"EdgeDB.subtransaction/2","type":"function"},{"doc":"","ref":"EdgeDB.html#subtransaction!/2","title":"EdgeDB.subtransaction!/2","type":"function"},{"doc":"Open a retryable transaction loop. EdgeDB clients support transactions that are robust to network errors, server failure, and some transaction conflicts. For more information see RFC . The result of the transaction is the {:ok, result} tuple, where result is the result of the callback function executed in the transaction. To rollback an open transaction, use EdgeDB.rollback/2 . EdgeDB.transaction/3 calls cannot be nested more than once. If you want to start a new transaction inside an already running one, you should use EdgeDB.subtransaction/2 , which will declare a new savepoint for the current transaction. iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , tickets } = EdgeDB . transaction ( pid , fn conn -&gt; ...(2)&gt; EdgeDB . query! ( conn , &quot;INSERT Ticket{ number := 2}&quot; ) ...(2)&gt; EdgeDB . query! ( conn , &quot;SELECT Ticket&quot; ) ...(2)&gt; end ) iex(3)&gt; tickets # EdgeDB.Set &lt; { # EdgeDB.Object &lt; &gt; } &gt; See transaction_option/0 for supported options.","ref":"EdgeDB.html#transaction/3","title":"EdgeDB.transaction/3","type":"function"},{"doc":"Configure the connection so that futher transactions retries are executed with custom retries options. See retry_option/0 for supported options.","ref":"EdgeDB.html#with_retry_options/2","title":"EdgeDB.with_retry_options/2","type":"function"},{"doc":"Configure the connection so that futher transactions are executed with custom transaction options. See edgedb_transaction_option/0 for supported options.","ref":"EdgeDB.html#with_transaction_options/2","title":"EdgeDB.with_transaction_options/2","type":"function"},{"doc":"Parameters for connecting to an EdgeDB instance and configuring the connection itself. EdgeDB clients allow a very flexible way to define how to connect to an instance. For more information, see the official EdgeDB documentation on connection parameters . Supported options: :dsn - DSN that defines the primary information that can be used to connect to the instance. :credentials - a JSON string containing the instance parameters to connect. :credentials_file - the path to the instance credentials file containing the instance parameters to connect to. :host - the host name of the instance to connect to. :port - the port number of the instance to connect to. :database - the name of the database to connect to. :user - the user name to connect to. :password - the user password to connect. :tls_ca - TLS certificate to be used when connecting to the instance. :tls_ca_path - the path to the TLS certificate to be used when connecting to the instance. :tls_security - security mode for the TLS connection. See tls_security/0 . :timeout - timeout for TCP operations with the database, such as connecting to it, sending or receiving data. :command_timeout - not in use right now and added for compatibility with the official drivers . :server_settings - not in use right now and added for compatibility with the official drivers . :tcp - options for the TCP connection. :ssl - options for TLS connection. :transaction - options for EdgeDB transactions, which correspond to the EdgeQL transaction statement . See edgedb_transaction_option/0 . :retry - options to retry transactions in case of errors. See retry_option/0 . :codecs - list of custom codecs for EdgeDB scalars.","ref":"EdgeDB.html#t:connect_option/0","title":"EdgeDB.connect_option/0","type":"type"},{"doc":"Connection process name, pid or the same but wrapped in a separate structure that allows special actions on the connection. See EdgeDB.as_readonly/1 , EdgeDB.with_retry_options/2 , EdgeDB.with_transaction_options/2 for more information.","ref":"EdgeDB.html#t:connection/0","title":"EdgeDB.connection/0","type":"type"},{"doc":"Options for EdgeDB transactions. These options are responsible for building the appropriate EdgeQL statement to start transactions and they correspond to the EdgeQL transaction statement . Supported options: :isolation - If :serializable is used, the built statement will use the ISOLATION SERIALIZABLE mode. Otherwise, if :repeatable_read is used, the built statement will use the ISOLATION REPEATABLE READ mode. The default is :repeatable_read . :readonly - if set to true then the built statement will use READ ONLY mode, otherwise READ WRITE will be used. The default is false . :deferrable - if set to true then the built statement will use DEFERRABLE mode, otherwise NOT DEFERRABLE will be used. The default is false .","ref":"EdgeDB.html#t:edgedb_transaction_option/0","title":"EdgeDB.edgedb_transaction_option/0","type":"type"},{"doc":"Options for EdgeDB.query*/4 functions. These options can be used with the following functions: EdgeDB.query/4 EdgeDB.query!/4 EdgeDB.query_single/4 EdgeDB.query_single!/4 EdgeDB.query_required_single/4 EdgeDB.query_required_single!/4 EdgeDB.query_json/4 EdgeDB.query_json!/4 EdgeDB.query_single_json/4 EdgeDB.query_single_json!/4 EdgeDB.query_required_single_json/4 EdgeDB.query_required_single_json!/4 Supported options: :cardinality - expected number of items in set. :io_format - preferred format of query result. :retry - options for read-only queries retries. :raw - flag to return internal driver structures for inspecting. other - check DBConnection.start_option/0 .","ref":"EdgeDB.html#t:query_option/0","title":"EdgeDB.query_option/0","type":"type"},{"doc":"A tuple of the executed EdgeDB.Query and the received EdgeDB.Result . This tuple can be useful if you want to get the internal structures of the driver and inspect them, but in most cases you will not use it.","ref":"EdgeDB.html#t:raw_result/0","title":"EdgeDB.raw_result/0","type":"type"},{"doc":"The result that will be returned if the EdgeDB.query*/4 function succeeds.","ref":"EdgeDB.html#t:result/0","title":"EdgeDB.result/0","type":"type"},{"doc":"Options for transactions and read-only queries retries. See EdgeDB.transaction/3 . Supported options: :transaction_conflict - the rule that will be used in case of any transaction conflict. :network_error - rule which will be used when any network error occurs on the client.","ref":"EdgeDB.html#t:retry_option/0","title":"EdgeDB.retry_option/0","type":"type"},{"doc":"Options for a retry rule for transactions retries. See EdgeDB.transaction/3 . Supported options: :attempts - the number of attempts to retry the transaction in case of an error. :backoff - function to determine the backoff before the next attempt to run a transaction.","ref":"EdgeDB.html#t:retry_rule/0","title":"EdgeDB.retry_rule/0","type":"type"},{"doc":"Options for EdgeDB.rollback/2 . Supported options: :reason - the reason for the rollback. Will be returned from EdgeDB.transaction/3 or EdgeDB.subtransaction/2 as a {:error, reason} tuple in case block execution is interrupted. :continue - can be used when the connection is in a subtransaction and rollback should not stop further execution of the subtransaction block. See EdgeDB.subtransaction/2 .","ref":"EdgeDB.html#t:rollback_option/0","title":"EdgeDB.rollback_option/0","type":"type"},{"doc":"Options for EdgeDB.start_link/1 . See connect_option/0 and DBConnection.start_option/0 .","ref":"EdgeDB.html#t:start_option/0","title":"EdgeDB.start_option/0","type":"type"},{"doc":"Security modes for TLS connection to EdgeDB server. For more information, see the official EdgeDB documentation on connection parameters . Supported options: :insecure - trust a self-signed or user-signed TLS certificate, which is useful for local development. :no_host_verification - verify the TLS certificate, but not the host name. :strict - verify both the TLS certificate and the hostname. :default - the same as :strict .","ref":"EdgeDB.html#t:tls_security/0","title":"EdgeDB.tls_security/0","type":"type"},{"doc":"Options for EdgeDB.transaction/3 . See edgedb_transaction_option/0 and DBConnection.start_option/0 .","ref":"EdgeDB.html#t:transaction_option/0","title":"EdgeDB.transaction_option/0","type":"type"},{"doc":"A structure carrying the information related to the query. It's mostly used in driver internally, but user can retrive it along with EdgeDB.Result struct from succeed query execution using :raw option for EdgeDB.query*/4 functions. See EdgeDB.query_option/0 .","ref":"EdgeDB.Query.html","title":"EdgeDB.Query","type":"module"},{"doc":"A structure carrying the information related to the query. Fields: :statement - EdgeQL statement for execution. :cardinality - the expected number of elements in the returned set as a result of the query. :io_format - the preferred format of the query result. :capabilities - query capabilities. See RFC for more information. :required - flag specifying that the result should not be empty. :input_codec - codec for encoding query parameters. :output_codec - codec for decoding the query result. :cached - flag specifying whether the request has already been cached by the connection. :params - query parameters.","ref":"EdgeDB.Query.html#t:t/0","title":"EdgeDB.Query.t/0","type":"type"},{"doc":"A structure that contains information related to the query result. It's mostly used in driver internally, but user can retrive it along with EdgeDB.Query struct from succeed query execution using :raw option for EdgeDB.query*/4 functions. See EdgeDB.query_option/0 .","ref":"EdgeDB.Result.html","title":"EdgeDB.Result","type":"module"},{"doc":"Process the result and extract the data.","ref":"EdgeDB.Result.html#extract/1","title":"EdgeDB.Result.extract/1","type":"function"},{"doc":"A structure that contains information related to the query result. Fields: :statement - EdgeQL statement that was executed. :required - flag specifying that the result should not be empty. :set - query result. :cardinality - the expected number of elements in the returned set as a result of the query.","ref":"EdgeDB.Result.html#t:t/0","title":"EdgeDB.Result.t/0","type":"type"},{"doc":"A structure to wrap a connection to EdgeDB. This is used in driver internally for changing the behaviour of operations. See EdgeDB.as_readonly/1 , EdgeDB.with_retry_options/2 and EdgeDB.with_transaction_options/2 for more information.","ref":"EdgeDB.WrappedConnection.html","title":"EdgeDB.WrappedConnection","type":"module"},{"doc":"Wrapped connection.","ref":"EdgeDB.WrappedConnection.html#t:t/0","title":"EdgeDB.WrappedConnection.t/0","type":"opaque"},{"doc":"An immutable value represeting an EdgeDB cfg::memory value as a quantity of memory storage. iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; mem = EdgeDB . query_required_single! ( pid , &quot;SELECT &lt;cfg::memory&gt;&#39;5KiB&#39;&quot; ) # EdgeDB.ConfigMemory &lt; &quot;5KiB&quot; &gt; iex(3)&gt; EdgeDB.ConfigMemory . bytes ( mem ) 5120","ref":"EdgeDB.ConfigMemory.html","title":"EdgeDB.ConfigMemory","type":"module"},{"doc":"Get a quantity of memory storage in bytes.","ref":"EdgeDB.ConfigMemory.html#bytes/1","title":"EdgeDB.ConfigMemory.bytes/1","type":"function"},{"doc":"An immutable value represeting an EdgeDB cfg::memory value as a quantity of memory storage.","ref":"EdgeDB.ConfigMemory.html#t:t/0","title":"EdgeDB.ConfigMemory.t/0","type":"opaque"},{"doc":"An immutable value representing an EdgeDB named tuple value. EdgeDB.NamedTuple implements Access behavior to access fields by index or key and Enumerable protocol for iterating over tuple values. iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; nt = EdgeDB . query_required_single! ( pid , &quot;SELECT (a := 1, b := &#39;a&#39;, c := [3])&quot; ) # EdgeDB.NamedTuple &lt; a : 1 , b : &quot;a&quot; , c : [ 3 ] &gt; iex(3)&gt; nt [ :b ] &quot;a&quot; iex(4)&gt; nt [ &quot;c&quot; ] [ 3 ] iex(4)&gt; nt [ 0 ] 1","ref":"EdgeDB.NamedTuple.html","title":"EdgeDB.NamedTuple","type":"module"},{"doc":"Get named tuple keys iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; nt = EdgeDB . query_required_single! ( pid , &quot;SELECT (a := 1, b := &#39;a&#39;, c := [3])&quot; ) iex(3)&gt; EdgeDB.NamedTuple . keys ( nt ) [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ]","ref":"EdgeDB.NamedTuple.html#keys/1","title":"EdgeDB.NamedTuple.keys/1","type":"function"},{"doc":"Convert a named tuple to a regular erlang tuple. iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; nt = EdgeDB . query_required_single! ( pid , &quot;SELECT (a := 1, b := &#39;a&#39;, c := [3])&quot; ) iex(3)&gt; EdgeDB.NamedTuple . to_tuple ( nt ) { 1 , &quot;a&quot; , [ 3 ] }","ref":"EdgeDB.NamedTuple.html#to_tuple/1","title":"EdgeDB.NamedTuple.to_tuple/1","type":"function"},{"doc":"An immutable value representing an EdgeDB named tuple value.","ref":"EdgeDB.NamedTuple.html#t:t/0","title":"EdgeDB.NamedTuple.t/0","type":"opaque"},{"doc":"An immutable representation of an object instance returned from a query. EdgeDB.Object implements Access behavior to access properties by key. iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; % EdgeDB.Object { } = object = iex(2)&gt; EdgeDB . query_required_single! ( pid , &quot; ...(2)&gt; SELECT schema::ObjectType{ ...(2)&gt; name ...(2)&gt; } ...(2)&gt; FILTER .name = &#39;std::Object&#39; ...(2)&gt; LIMIT 1 ...(2)&gt; &quot; ) # EdgeDB.Object &lt; name := &quot;std::Object&quot; &gt; iex(3)&gt; object [ :name ] &quot;std::Object&quot; iex(4)&gt; object [ &quot;name&quot; ] &quot;std::Object&quot; Links and links properties In EdgeDB, objects can have links to other objects or a set of objects. You can use the same syntax to access links values as for object properties. Links can also have their own properties (denoted as @&lt;link_prop_name&gt; in EdgeQL syntax). You can use the same property name as in the query to access them from the links. iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; % EdgeDB.Object { } = object = iex(2)&gt; EdgeDB . query_required_single! ( pid , &quot; ...(2)&gt; SELECT schema::Property { ...(2)&gt; name, ...(2)&gt; annotations: { ...(2)&gt; name, ...(2)&gt; @value ...(2)&gt; } ...(2)&gt; } ...(2)&gt; FILTER .name = &#39;listen_port&#39; AND .source.name = &#39;cfg::Config&#39; ...(2)&gt; LIMIT 1 ...(2)&gt; &quot; ) # EdgeDB.Object &lt; name := &quot;listen_port&quot; , annotations := # EdgeDB.Set &lt; { # EdgeDB.Object &lt; name := &quot;cfg::system&quot; , @value := &quot;true&quot; &gt; } &gt; &gt; iex(3)&gt; annotations = object [ :annotations ] # EdgeDB.Set &lt; { # EdgeDB.Object &lt; name := &quot;cfg::system&quot; , @value := &quot;true&quot; &gt; } &gt; iex(4)&gt; link = Enum . at ( annotations , 0 ) # EdgeDB.Object &lt; name := &quot;cfg::system&quot; , @value := &quot;true&quot; &gt; iex(5)&gt; link [ &quot;@value&quot; ] &quot;true&quot;","ref":"EdgeDB.Object.html","title":"EdgeDB.Object","type":"module"},{"doc":"An immutable representation of an object instance returned from a query. Fields: :id - a unique ID of the object instance in the database.","ref":"EdgeDB.Object.html#t:t/0","title":"EdgeDB.Object.t/0","type":"type"},{"doc":"UUID value.","ref":"EdgeDB.Object.html#t:uuid/0","title":"EdgeDB.Object.uuid/0","type":"type"},{"doc":"An immutable value represeting an EdgeDB cal::relative_duration value. iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; EdgeDB . query_required_single! ( pid , &quot;SELECT &lt;cal::relative_duration&gt;&#39;45.6 seconds&#39;&quot; ) # EdgeDB.RelativeDuration &lt; &quot;PT45.6S&quot; &gt;","ref":"EdgeDB.RelativeDuration.html","title":"EdgeDB.RelativeDuration","type":"module"},{"doc":"An immutable value represeting an EdgeDB cal::relative_duration value. Fields: :months - number of months. :days - number of months. :microseconds - number of microseconds.","ref":"EdgeDB.RelativeDuration.html#t:t/0","title":"EdgeDB.RelativeDuration.t/0","type":"type"},{"doc":"A representation of an immutable set of values returned by a query. Nested sets in the result are also returned as EdgeDB.Set objects. EdgeDB.Set implements Enumerable protocol for iterating over set values. iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; % EdgeDB.Set { } = iex(2)&gt; EdgeDB . query! ( pid , &quot; ...(2)&gt; SELECT schema::ObjectType{ ...(2)&gt; name ...(2)&gt; } ...(2)&gt; FILTER .name IN {&#39;std::BaseObject&#39;, &#39;std::Object&#39;, &#39;std::FreeObject&#39;} ...(2)&gt; ORDER BY .name ...(2)&gt; &quot; ) # EdgeDB.Set &lt; { # EdgeDB.Object &lt; name := &quot;std::BaseObject&quot; &gt; , # EdgeDB.Object &lt; name := &quot;std::FreeObject&quot; &gt; , # EdgeDB.Object &lt; name := &quot;std::Object&quot; &gt; } &gt;","ref":"EdgeDB.Set.html","title":"EdgeDB.Set","type":"module"},{"doc":"Check if set is empty. iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; % EdgeDB.Set { } = set = EdgeDB . query! ( pid , &quot;SELECT Ticket&quot; ) iex(3)&gt; EdgeDB.Set . empty? ( set ) true","ref":"EdgeDB.Set.html#empty?/1","title":"EdgeDB.Set.empty?/1","type":"function"},{"doc":"A representation of an immutable set of values returned by a query.","ref":"EdgeDB.Set.html#t:t/0","title":"EdgeDB.Set.t/0","type":"opaque"},{"doc":"A codec structure knows how to work with the internal binary data from EdgeDB. The binary protocol specification for the codecs can be found on the official EdgeDB site . Useful links for codec developers: EdgeDB datatypes used in data descriptions . EdgeDB data wire formats . Built-in EdgeDB codec implementations . Custom codecs implementations . Guide to developing custom codecs .","ref":"EdgeDB.Protocol.Codec.html","title":"EdgeDB.Protocol.Codec","type":"behaviour"},{"doc":"Decode EdgeDB binary data into an enitity using the codec.","ref":"EdgeDB.Protocol.Codec.html#decode/2","title":"EdgeDB.Protocol.Codec.decode/2","type":"function"},{"doc":"Decode binary data from EdgeDB format to the expected entity.","ref":"EdgeDB.Protocol.Codec.html#c:decode_instance/1","title":"EdgeDB.Protocol.Codec.decode_instance/1","type":"callback"},{"doc":"Macros for defining custom scalar codecs implementation. See custom codecs development guide for more information.","ref":"EdgeDB.Protocol.Codec.html#defscalarcodec/1","title":"EdgeDB.Protocol.Codec.defscalarcodec/1","type":"macro"},{"doc":"Encode an entity into EdgeDB binary format using the codec.","ref":"EdgeDB.Protocol.Codec.html#encode/2","title":"EdgeDB.Protocol.Codec.encode/2","type":"function"},{"doc":"Encode the entity into EdgeDB binary format.","ref":"EdgeDB.Protocol.Codec.html#c:encode_instance/1","title":"EdgeDB.Protocol.Codec.encode_instance/1","type":"callback"},{"doc":"Options for defining custom codecs with EdgeDB.Protocol.Codec.defscalarcodec/1 . Supported options: :type - typepec for the type that can be processed by the encoder/decoder function. :type_name - the name of the EdgeDB type that can be processed by codec. :calculate_size - flag specifying whether to automatically calculate the payload size for the encoder/decoder.","ref":"EdgeDB.Protocol.Codec.html#t:codec_option/0","title":"EdgeDB.Protocol.Codec.codec_option/0","type":"type"},{"doc":"Function that can decode EdgeDB binary format into an entity.","ref":"EdgeDB.Protocol.Codec.html#t:decoder/0","title":"EdgeDB.Protocol.Codec.decoder/0","type":"type"},{"doc":"Function that can encode an entity to EdgeDB binary format.","ref":"EdgeDB.Protocol.Codec.html#t:encoder/0","title":"EdgeDB.Protocol.Codec.encoder/0","type":"type"},{"doc":"A codec structure knows how to work with the internal binary data from EdgeDB. Fields: :type_id - EdgeDB type ID that can be encoded/decoded by the codec. :type_name - optional name of the type that can be encoded/decoded by the codec. :encoder - function that can encode an entity to EdgeDB binary format. :decoder - function that can decode EdgeDB binary format into an entity. :module - module which defines the implementation of the codec. :parent - module, which was used as the base for the implementation of the codec. :is_scalar - flag specifying that the codec is used to encode/decode EdgeDB scalar values.","ref":"EdgeDB.Protocol.Codec.html#t:t/0","title":"EdgeDB.Protocol.Codec.t/0","type":"type"},{"doc":"UUID value.","ref":"EdgeDB.Protocol.Codec.html#t:uuid/0","title":"EdgeDB.Protocol.Codec.uuid/0","type":"type"},{"doc":"Query capabilities. Values: :readonly - query is read-only. :modifications - query is not read-only. :session_config - query contains session config change. :transaction - query contains start/commit/rollback of transaction or savepoint manipulation. :ddl - query contains DDL. :persistent_config - server or database config change. :all - all possible capabilities. :execute - capabilities to execute query.","ref":"EdgeDB.Protocol.Enums.Capabilities.html","title":"EdgeDB.Protocol.Enums.Capabilities","type":"module"},{"doc":"Query capabilities. Values: :readonly - query is read-only. :modifications - query is not read-only. :session_config - query contains session config change. :transaction - query contains start/commit/rollback of transaction or savepoint manipulation. :ddl - query contains DDL. :persistent_config - server or database config change. :all - all possible capabilities. :execute - capabilities to execute query.","ref":"EdgeDB.Protocol.Enums.Capabilities.html#t:t/0","title":"EdgeDB.Protocol.Enums.Capabilities.t/0","type":"type"},{"doc":"Cardinality of the query result. Values: :no_result - query doesn't return anything. :at_most_one - query return an optional single elements. :one - query return a single element. :many - query return a set of elements. :at_least_one - query return a set with at least of one elements.","ref":"EdgeDB.Protocol.Enums.Cardinality.html","title":"EdgeDB.Protocol.Enums.Cardinality","type":"module"},{"doc":"Cardinality of the query result. Values: :no_result - query doesn't return anything. :at_most_one - query return an optional single elements. :one - query return a single element. :many - query return a set of elements. :at_least_one - query return a set with at least of one elements.","ref":"EdgeDB.Protocol.Enums.Cardinality.html#t:t/0","title":"EdgeDB.Protocol.Enums.Cardinality.t/0","type":"type"},{"doc":"Data I/O format. Values: :binary - return data encoded in binary. :json - return data as single row and single field that contains the result set as a single JSON array. :json_elements - return a single JSON string per top-level set element. This can be used to iterate over a large result set efficiently.","ref":"EdgeDB.Protocol.Enums.IOFormat.html","title":"EdgeDB.Protocol.Enums.IOFormat","type":"module"},{"doc":"Data I/O format. Values: :binary - return data encoded in binary. :json - return data as single row and single field that contains the result set as a single JSON array. :json_elements - return a single JSON string per top-level set element. This can be used to iterate over a large result set efficiently.","ref":"EdgeDB.Protocol.Enums.IOFormat.html#t:t/0","title":"EdgeDB.Protocol.Enums.IOFormat.t/0","type":"type"},{"doc":"Exception returned by the driver if an error occurred. Most of the functions in the EdgeDB.Error module are a shorthands for simplifying EdgeDB.Error exception constructing. These functions are generated at compile time from a copy of the errors.txt file.","ref":"EdgeDB.Error.html","title":"EdgeDB.Error","type":"exception"},{"doc":"Check if should try to reconnect to EdgeDB server. NOTE : this function is not used right now, because DBConnection reconnects it connection itself.","ref":"EdgeDB.Error.html#reconnect?/1","title":"EdgeDB.Error.reconnect?/1","type":"function"},{"doc":"Check if should try to repeat the query during the execution of which an error occurred.","ref":"EdgeDB.Error.html#retry?/1","title":"EdgeDB.Error.retry?/1","type":"function"},{"doc":"Options for constructing an EdgeDB.Error instance. Supported options: :code - internal error code. :attributes - additional error attributes that can be obtained from the ErrorResponse server message. :query - query, which should have been executed when the error occurred.","ref":"EdgeDB.Error.html#t:option/0","title":"EdgeDB.Error.option/0","type":"type"},{"doc":"Exception returned by the driver if an error occurred. Fields: :message - human-readable error message. :name - error name from EdgeDB. :code - internal error code. :attributes - additional error attributes that can be obtained from the ErrorResponse server message. :tags - error tags. :query - query, which should have been executed when the error occurred.","ref":"EdgeDB.Error.html#t:t/0","title":"EdgeDB.Error.t/0","type":"type"},{"doc":"Error tags.","ref":"EdgeDB.Error.html#t:tag/0","title":"EdgeDB.Error.tag/0","type":"type"},{"doc":"edgedb-elixir is the EdgeDB driver for Elixir.","ref":"main.html","title":"EdgeDB driver for Elixir","type":"extras"},{"doc":"edgedb-elixir is available in hex.pm and can be installed via mix . Just add :edgedb to your dependencies in the mix.exs file: { :edgedb , &quot;~&gt; 0.1&quot; }","ref":"main.html#installation","title":"EdgeDB driver for Elixir - Installation","type":"extras"},{"doc":"EdgeDB comes with JSON support out of the box via the Jason library. To use it, add :jason to your dependencies in the mix.exs file: { :jason , &quot;~&gt; 1.0&quot; } The JSON library can be configured using the :json option in the :edgedb application configuration: config :edgedb , json : CustomJSONLibrary The JSON library is injected in the compiled EdgeDB code, so be sure to recompile EdgeDB if you change it: mix deps.clean edgedb --build","ref":"main.html#json-support","title":"EdgeDB driver for Elixir - JSON support","type":"extras"},{"doc":"This project is licensed under the terms of the MIT license. See LICENSE for details.","ref":"main.html#license","title":"EdgeDB driver for Elixir - License","type":"extras"},{"doc":"The basic user API for edgedb-elixir is provided by the EdgeDB module and in most cases you will use only it. The exception is when you want to define custom codecs . EdgeDB provides several functions for querying data from the database, which are named in EdgeDB.query*/4 format. Transactions are supported with EdgeDB.transaction/3 function and subtransactions (including nested ones) with EdgeDB.subtransaction/2 function.","ref":"usage.html","title":"Usage","type":"extras"},{"doc":"edgedb-elixir , like official clients, allows a very flexible way to define how to connect to an instance. For more information, see EdgeDB.connect_option/0 . The examples on this page will involve connecting to an instance using edgedb projects . Run edgedb project init to initialize the project: edgedb project init Database schema Ensure that your database has the following schema: module default { type User { required property name -&gt; str { constraint exclusive; }; } type Post { required property body -&gt; str; required link author -&gt; User; multi link comments -&gt; Post; } }; Let's fill the database with some data, which will be used in further examples: iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; EdgeDB . query! ( pid , &quot; ...(2)&gt; WITH ...(2)&gt; p1 := ( ...(2)&gt; INSERT Post { ...(2)&gt; body := &#39;Yes!&#39;, ...(2)&gt; author := ( ...(2)&gt; INSERT User { ...(2)&gt; name := &#39;commentator1&#39; ...(2)&gt; } ...(2)&gt; ) ...(2)&gt; } ...(2)&gt; ), ...(2)&gt; p2 := ( ...(2)&gt; INSERT Post { ...(2)&gt; body := &#39;Absolutely amazing&#39;, ...(2)&gt; author := ( ...(2)&gt; INSERT User { ...(2)&gt; name := &#39;commentator2&#39; ...(2)&gt; } ...(2)&gt; ) ...(2)&gt; } ...(2)&gt; ), ...(2)&gt; p3 := ( ...(2)&gt; INSERT Post { ...(2)&gt; body := &#39;FYI here is a link to the Elixir driver: https://hex.pm/packages/edgedb&#39;, ...(2)&gt; author := ( ...(2)&gt; INSERT User { ...(2)&gt; name := &#39;commentator3&#39; ...(2)&gt; } ...(2)&gt; ) ...(2)&gt; } ...(2)&gt; ) ...(2)&gt; INSERT Post { ...(2)&gt; body := &#39;EdgeDB is awesome! Try the Elixir driver for it&#39;, ...(2)&gt; author := ( ...(2)&gt; INSERT User { ...(2)&gt; name := &#39;author1&#39; ...(2)&gt; } ...(2)&gt; ), ...(2)&gt; comments := {p1, p2, p3} ...(2)&gt; } ...(2)&gt; &quot; )","ref":"usage.html#establishing-a-connection","title":"Usage - Establishing a connection","type":"extras"},{"doc":"Depending on the expected results of the query, you can use different functions to retrieve data from the database. This is called the cardinality of the result and is better explained in the official documentation . Querying a set of elements If you want to receive an EdgeDB.Set from your query, just use the EdgeDB.query/4 or EdgeDB.query!/4 functions. The difference between the two functions is that EdgeDB.query/4 will return an :ok tuple with result if successful or a :error tuple with EdgeDB.Error if an error occurred during the query execution. EdgeDB.query!/4 will return a plain result if successful or raise EdgeDB.Error if error. Let's query all existing posts with their bodies: iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , posts } = EdgeDB . query ( pid , &quot;SELECT Post { body }&quot; ) { :ok , # EdgeDB.Set &lt; { # EdgeDB.Object &lt; body := &quot;EdgeDB is awesome! Try the Elixir driver for it&quot; &gt; , # EdgeDB.Object &lt; body := &quot;Yes!&quot; &gt; , # EdgeDB.Object &lt; body := &quot;Absolutely amazing&quot; &gt; , # EdgeDB.Object &lt; body := &quot;FYI here is a link to the Elixir driver: https://hex.pm/packages/edgedb&quot; &gt; } &gt; } We can iterate over EdgeDB.Set and inspect each object separately: iex(3)&gt; Enum . each ( posts , fn % EdgeDB.Object { } = post -&gt; ...(3)&gt; IO . inspect ( post [ :body ] , label : &quot;post ( \#{ inspect ( post . id ) } )&quot; ) ...(3)&gt; end ) post ( &quot;3c5c8cf2-860f-11ec-a22a-2b0ab4e21d4b&quot; ) : &quot;EdgeDB is awesome! Try the Elixir driver for it&quot; post ( &quot;3c5c904e-860f-11ec-a22a-f7cdb9bcb510&quot; ) : &quot;Yes!&quot; post ( &quot;3c5c9256-860f-11ec-a22a-0343fa0961f3&quot; ) : &quot;Absolutely amazing&quot; post ( &quot;3c5c9378-860f-11ec-a22a-0713dfca8baa&quot; ) : &quot;FYI here is a link to the Elixir driver: https://hex.pm/packages/edgedb&quot; :ok Querying a single element If you know that the query will return only one element or none, you can use EdgeDB.query_single/4 and EdgeDB.query_single!/4 functions. This function will automatically unpack the underlying EdgeDB.Set and return the requested item (or nil if the set is empty). Let's query a post with a link to the Elixir driver for EdgeDB: iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; % EdgeDB.Object { } = post = EdgeDB . query_single! ( pid , &quot;SELECT Post FILTER contains(.body, &#39;https://hex.pm/packages/edgedb&#39;) LIMIT 1&quot; ) iex(3)&gt; post . id &quot;3c5c9378-860f-11ec-a22a-0713dfca8baa&quot; If we try to select a Post that does not exist, nil will be returned: iex(4)&gt; EdgeDB . query_single! ( pid , &quot;SELECT Post FILTER .body = &#39;lol&#39; LIMIT 1&quot; ) nil Querying a requried single element In case we want to ensure that the requested element must exist, we can use the functions EdgeDB.query_required_single/4 and EdgeDB.query_required_single!/4 . Instead of returning nil they will return EdgeDB.Error in case of a missing element: iex(5)&gt; EdgeDB . query_required_single! ( pid , &quot;SELECT Post FILTER .body = &#39;lol&#39; LIMIT 1&quot; ) ** (EdgeDB.Error) NoDataError: expected result, but query did not return any data","ref":"usage.html#querying-data-from-edgedb","title":"Usage - Querying data from EdgeDB","type":"extras"},{"doc":"The API for transactions is provided by the EdgeDB.transaction/3 function: iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , user } = ...(2)&gt; EdgeDB . transaction ( pid , fn conn -&gt; ...(2)&gt; EdgeDB . query_required_single! ( conn , &quot;INSERT User { name := &lt;str&gt;$username }&quot; , username : &quot;user1&quot; ) ...(2)&gt; end ) Transactions can be rollbacked using the EdgeDB.rollback/2 function or automatically if an error has occurred inside a transaction block: iex(3)&gt; { :error , :rollback } = ...(3)&gt; EdgeDB . transaction ( pid , fn conn -&gt; ...(3)&gt; % EdgeDB.Object { } = EdgeDB . query_required_single! ( conn , &quot;INSERT User { name := &lt;str&gt;$username }&quot; , username : &quot;wrong_username&quot; ) ...(3)&gt; EdgeDB . rollback ( conn ) ...(3)&gt; end ) iex(4)&gt; EdgeDB . query_single! ( pid , &quot;SELECT User { name } FILTER .name = &lt;str&gt;$username&quot; , username : &quot;wrong_username&quot; ) nil Transactions are retriable. This means that if certain types of errors occur when querying data from the database, the transaction block can be automatically retried. The following types of errors can be retried retried: TransactionConflictError and its inheritors. Network errors (e.g. a socket was closed). As an example, let's create a transaction conflict to show how this works. In the first example, we will disable retries: iex(5)&gt; callback = fn conn , body -&gt; ...(5)&gt; Process . sleep ( 500 ) ...(5)&gt; EdgeDB . query! ( conn , &quot;UPDATE Post FILTER .author.id = &lt;uuid&gt;$user_id SET { body := &lt;str&gt;$new_body }&quot; , user_id : user . id , new_body : body ) ...(5)&gt; Process . sleep ( 500 ) ...(5)&gt; end iex(6)&gt; spawn ( fn -&gt; ...(6)&gt; { :ok , pid } = EdgeDB . start_link ( ) ...(6)&gt; EdgeDB . transaction ( pid , &amp; callback . ( &amp;1 , &quot;new_body_1&quot; ) ) ...(6)&gt; end ) iex(7)&gt; EdgeDB . transaction ( pid , &amp; callback . ( &amp;1 , &quot;new_body_2&quot; ) , retry : [ transaction_conflict : [ attempts : 0 ] ] ) ** (EdgeDB.Error) TransactionSerializationError: could not serialize access due to concurrent update Now let's execute the same thing but with enabled retries: iex(8)&gt; spawn ( fn -&gt; ...(8)&gt; { :ok , pid } = EdgeDB . start_link ( ) ...(8)&gt; EdgeDB . transaction ( pid , &amp; callback . ( &amp;1 , &quot;new_body_1&quot; ) ) ...(8)&gt; end ) iex(9)&gt; EdgeDB . transaction ( pid , &amp; callback . ( &amp;1 , &quot;new_body_2&quot; ) ) { :ok , :ok } All failed transactions will be retried until they succeed or until the number of retries exceeds the limit (the default is 3). Note that EdgeDB.transaction/3 calls cannot be nested. If you want to open a nested transaction, you should use EdgeDB.subtransaction/2 instead: iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , % EdgeDB.Set { } } = ...(2)&gt; EdgeDB . transaction ( pid , fn tx_conn -&gt; ...(2)&gt; EdgeDB . subtransaction! ( tx_conn , fn subtx_conn1 -&gt; ...(2)&gt; EdgeDB . subtransaction! ( subtx_conn1 , fn subtx_conn2 -&gt; ...(2)&gt; EdgeDB . query! ( subtx_conn2 , &quot;INSERT User { name := &lt;str&gt;$username }&quot; , username : &quot;user_subtx2&quot; ) ...(2)&gt; EdgeDB . rollback ( subtx_conn2 , continue : true ) ...(2)&gt; EdgeDB . query! ( subtx_conn2 , &quot;INSERT User { name := &lt;str&gt;$username }&quot; , username : &quot;user_subtx2_ver_2&quot; ) ...(2)&gt; :ok ...(2)&gt; end ) ...(2)&gt; EdgeDB . query! ( subtx_conn1 , &quot;INSERT User { name := &lt;str&gt;$username }&quot; , username : &quot;user_subtx1&quot; ) ...(2)&gt; EdgeDB . query! ( subtx_conn1 , &quot;SELECT User { name } FILTER .name ILIKE &#39;%subtx%&#39;&quot; ) ...(2)&gt; end ) ...(2)&gt; end ) { :ok , # EdgeDB.Set &lt; { # EdgeDB.Object &lt; name := &quot;user_subtx2_ver_2&quot; &gt; , # EdgeDB.Object &lt; name := &quot;user_subtx1&quot; &gt; } &gt; }","ref":"usage.html#transactions","title":"Usage - Transactions","type":"extras"},{"doc":"You can also check out an example application using this driver to see how to work with it: https://github.com/nsidnev/edgedb-phoenix-example","ref":"usage.html#example","title":"Usage - Example","type":"extras"},{"doc":"EdgeDB driver for Elixir automatically converts EdgeDB types to the corresponding Elixir types and vice versa. The table below shows the correspondence between EdgeDB and Elixir types. EdgeDB Elixir Example set EdgeDB.Set.t/0 #EdgeDB.Set&lt;{1, 2, 3}&gt;} array&lt;anytype&gt; list/0 [1, 2, 3] anytuple tuple/0 or EdgeDB.NamedTuple.t/0 {1, 2, 3} , #EdgeDB.NamedTuple&lt;a: 1, b: 2, c: 3&gt;} anyenum String.t/0 &quot;green&quot; Object EdgeDB.Object.t/0 #EdgeDB.Object&lt;name := &quot;username&quot;&gt;} bool boolean/0 true , false bytes binary/0 &lt;&lt;1, 2, 3&gt;&gt; , &quot;some bytes&quot; str String.t/0 &quot;Hello EdgeDB!&quot; cal::local_date Date.t/0 ~D[2018-05-07] cal::local_time Time.t/0 ~T[15:01:22] cal::local_datetime NaiveDateTime.t/0 ~N[2018-05-07 15:01:22] cal::relative_duration EdgeDB.RelativeDuration.t/0 #EdgeDB.RelativeDuration&lt;&quot;PT45.6S&quot;&gt; datetime DateTime.t/0 ~U[2018-05-07 15:01:22Z] duration integer/0 -420000000 float32 , float64 float/0 3.1415 int16 , int32 , int64 , bigint integer/0 16 decimal Decimal.t/0 #Decimal&lt;1.23&gt; json any/0 42 uuid String.t/0 &quot;0eba1636-846e-11ec-845e-276b0105b857&quot;","ref":"datatypes.html","title":"Datatypes","type":"extras"},{"doc":"EdgeDB.Protocol.Codec is a structure that knows how to encode or decode Elixir types into EdgeDB types and vice versa using the EdgeDB binary format. Custom codecs can be useful when your EdgeDB scalars need their own processing. You can use the EdgeDB.Protocol.Codec.defscalarcodec/1 macros to define a custom codec. It will generate code with EdgeDB.Protocol.Codec behavior, which will require implementing EdgeDB.Protocol.Codec.encode_instance/1 and EdgeDB.Protocol.Codec.decode_instance/1 callbacks. In most cases you can use already defined codecs to work with the EdgeDB binary protocol. Otherwise, you will need to check to the EdgeDB binary protocol documentation . As an example, let's create a custom codec for a scalar that extends the standard std::json type. module default { scalar type JSONPayload extending json; type User { required property name -&gt; str { constraint exclusive; }; required property payload -&gt; JSONPayload; } }; We will convert the following structure to default::JSONPayload : defmodule MyApp.Users.Payload do defstruct [ :public_id , :first_name , :last_name ] @type t ( ) :: % __MODULE__ { public_id : integer ( ) , first_name : String . t ( ) , last_name : String . t ( ) } end The implementation of the codec itself: defmodule MyApp.EdgeDB.Codecs.JSONPayload do use EdgeDB.Protocol.Codec alias EdgeDB.Protocol.Codecs alias MyApp.Users.Payload defscalarcodec ( type_name : &quot;default::JSONPayload&quot; , type : Payload . t ( ) , calculate_size : false # we need that because the JSON codec calculates its own size and we rely on JSON codec ) @impl EdgeDB.Protocol.Codec def encode_instance ( % Payload { } = payload ) do payload |&gt; Map . from_struct ( ) |&gt; Codecs.Builtin.JSON . encode_instance ( ) end @impl EdgeDB.Protocol.Codec def decode_instance ( binary_data ) do %{ &quot;public_id&quot; =&gt; public_id , &quot;first_name&quot; =&gt; first_name , &quot;last_name&quot; =&gt; last_name } = Codecs.Builtin.JSON . decode_instance ( binary_data ) % Payload { public_id : public_id , first_name : first_name , last_name : last_name } end end Now let's test this codec: iex(1)&gt; { :ok , pid } = EdgeDB . start_link ( codecs : [ MyApp.EdgeDB.Codecs.JSONPayload ] ) iex(1)&gt; payload = % MyApp.Users.Payload { public_id : 1 , first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; } iex(2)&gt; EdgeDB . query! ( pid , &quot;INSERT User { name := &lt;str&gt;$username, payload := &lt;JSONPayload&gt;$payload }&quot; , username : &quot;user&quot; , payload : payload ) iex ( 3 ) EdgeDB.Object { } = EdgeDB . query_required_single! ( pid , &quot;SELECT User {name, payload} FILTER .name = &#39;user&#39; LIMIT 1&quot; ) # EdgeDB.Object &lt; name := &quot;user&quot; , payload := % MyApp.Users.Payload { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , public_id : 1 } &gt;","ref":"custom-codecs.html","title":"Custom codecs for EdgeDB scalars","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Compare with 0.1.0","ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","type":"extras"},{"doc":"Compare with first commit Added First release.","ref":"changelog.html#0-1-0-2022-02-10","title":"Changelog - [0.1.0] - 2022-02-10","type":"extras"}]